//SLAVE 3
//SERVO

// put your setup code here, to run once:
#include <Servo.h>
#include <Wire.h>                     //include wire library for I2C bus (for master/slave arduino pairing)


Servo servoLeft;  // create servo object to control a servo, servo left side
Servo servoRight;  // servo right side

int pos = 0;    // variable to store the servo position in degrees

const int slaveAddress = 15;          //address of this slave arduino
char x=0;                             //"order" character received that directs the program
int count=0;

int timing = 5000;                    //overall LCD timing delay

void setup() {

  //attaching servo motors to pins
  servoLeft.attach(3);  // LEFT
  servoRight.attach(5);  // RIGHT
  
  //setup slave arduino address
  Wire.begin(slaveAddress);
  Serial.begin(9600);
  Wire.onReceive(receiveEvent);
  Serial.println("initialized");


}
void receiveEvent(char bytes){
  x = Wire.read();
  Serial.print("Order received: ");
  Serial.println(x);
}

//Servo arm swinging functions

void both(){                 //Swings both arms
  Serial.println("SWING");   //print to monitor which side is triggered
  servoLeft.write(180); 
  servoRight.write(0);       //set servo motor to move to the 180 degree position
  delay(400);                //wait 400 milliseconds (this is the amount of time the servo takes to spin to the 180 degree position)
                             //otherwise it would just stay at the 0 position due to the next line
  servoLeft.write(0);   
  servoRight.write(180);     //return servo motor to the 0 degree position
  delay (400);               //wait 5 seconds in order to prevent triggering the other servo motor
}

void freakOut(){             //slappy boi freaks out if there no one is in front of it
  Serial.println("SWING");   //print to monitor which side is triggered
  servoLeft.write(180); 
  servoRight.write(0);
  delay(400);             
  servoLeft.write(0);   
  servoRight.write(180);
  delay (400);             
  servoLeft.write(180); 
  servoRight.write(0);
  delay(400);
  servoLeft.write(0);   
  servoRight.write(180);
  delay (400);  
  servoLeft.write(180); 
  servoRight.write(0);
  delay(400);
  servoLeft.write(0);   
  servoRight.write(180);
  delay (400);
}

void loop() {
  // put your main code here, to run repeatedly:
  
  Serial.println("waiting");
    if(x == '1'){                               //PRODUCTIVE_1
      Serial.println("01_Productive");
      
     
      delay(timing);
      while(x != 'c'){                            //WAIT FOR INPUT OR FOR TIMEOUT
        Serial.print("waiting: ");
        Serial.println(count);
        count++;
        if(x == 'a'){                             //PRODUCTIVE_1A
          Serial.println("01A_Productive_Yes");
          both();
         
          delay(timing);
          x = '0';
          break;
        }else if(x == 'b'){                       //PRODUCTIVE_1B
          Serial.println("01B_Productive_No");
          both();
          delay(timing);
          x = '0';
          break;
        }
      }
      if(x != '0'){                       //PRODUCTIVE_1C
          Serial.println("01C_Productive_Timeout");
          both();

          x = '0';
          delay(timing);
        }
    }else if(x == '2'){                               //HAPPY_2
      Serial.println("02_Happy");
      
      delay(timing);
      while(x != 'f'){                            //WAIT FOR INPUT OR FOR TIMEOUT
        Serial.print("waiting: ");
        Serial.println(count);
        count++;
        if(x == 'd'){                             //HAPPY_2A
          Serial.println("02_Happy_Yes");
          both();
          delay(timing);
          x = '0';
          break;
        }else if(x == 'e'){                       //HAPPY_2B
          Serial.println("02_Happy_No");
          both();
          delay(timing);
          x = '0';
          break;
        }
      }
      if(x != '0'){                       //HAPPY_2C
          Serial.println("02_Happy_Timeout");
          both();
          x = '0';
          delay(timing);
        }
    }else if(x == '3'){                               //GREENBTTN_3
      Serial.println("03_GreenBttn");
      
      delay(timing);
      while(x != 'i'){                            //WAIT FOR INPUT OR FOR TIMEOUT
        Serial.print("waiting: ");
        Serial.println(count);
        count++;
        if(x == 'g'){                             //GREENBTTN_3A
          Serial.println("03_GreenBttn_Yes");
          both();
          
          delay(timing);
          x = '0';
          break;
        }else if(x == 'h'){                       //GREENBTTN_3B
          Serial.println("03_GreenBttn_No");
          both();
          delay(timing);
          x = '0';
          break;
        }
      }
      if(x != '0'){                       //GREENBTTN_3C
          Serial.println("03_GreenBttn_Timeout");
          both();
         
          x = '0';
          delay(timing);
        }
    }/*else if(x == '4'){                               //FOCUS_4
      Serial.println("04_Focus");
      //both();
      tmrpcm.stopPlayback();
      tmrpcm.play("focus.wav");
      delay(timing);
      while(x != 'l'){                            //WAIT FOR INPUT OR FOR TIMEOUT
        Serial.print("waiting: ");
        Serial.println(count);
        count++;
        if(x == 'j'){                             //FOCUS_4A
          Serial.println("04_Focus_Yes");
          //both();
          tmrpcm.play("arent.wav");
          delay(timing);
          x = '0';
          break;
        }else if(x == 'k'){                       //FOCUS_4B
          Serial.println("04_Focus_No");
          //both();
          tmrpcm.play("imbeciles.wav");
          delay(timing);
          x = '0';
          break;
        }
      }
      if(x != '0'){                       //FOCUS_4C
          Serial.println("04_Focus_Timeout");
          //both();
          tmrpcm.play("maybe.wav");
          x = '0';
          delay(timing);
        }
    }else if(x == '5'){                               //ASLEEP_5
      Serial.println("05_Asleep");
      both();
      tmrpcm.stopPlayback();
      tmrpcm.play("asleep.wav");
      delay(timing);
      while(x != 'o'){                            //WAIT FOR INPUT OR FOR TIMEOUT
        Serial.print("waiting: ");
        Serial.println(count);
        count++;
        if(x == 'm'){                             //ASLEEP_5A
          Serial.println("05_Asleep_Yes");
          both();
          tmrpcm.play("arent.wav");
          delay(timing);
          x = '0';
          break;
        }else if(x == 'n'){                       //ASLEEP_5B
          Serial.println("05_Asleep_No");
          both();
          tmrpcm.play("maybe.wav");
          delay(timing);
          x = '0';
          break;
        }
      }
      if(x != '0'){                       //ASLEEP_5C
          Serial.println("05_Asleep_Timeout");
          both();
          tmrpcm.play("maybe.wav");
          x = '0';
          delay(timing);
        }
    }*/else if(x == '9'){         //distance is too far from ultrasonic            
      x = '0';
      freakOut();
      delay(timing);
    }
  
  
  
} 
